{% macro product_list_variable_variation_form(shop_product, quantity, variation_info, supplier=None) %}
    {% if shop_product.product.variation_parent %}
        {%- set product_id = shop_product.product.variation_parent.pk -%}
    {% else %}
        {%- set product_id = shop_product.product.pk -%}
    {% endif %}
    <input type="hidden" name="command" value="add_var">
    <input type="hidden" name="product_id" id="product_id_{{ product_id }}" value="{{ shop_product.product.id }}">
    <div class="product-variations" id="complex-variations-{{ shop_product.product.id }}">
        {% for var in variation_info.variation_variables %}
            <div class="form-group">
                <span>{% trans %}Select{% endtrans %} {{ var.name }}</span><br>
                <select name="var_{{ var.pk }}"
                        id="var_{{ var.pk }}"
                        class="form-control selectpicker variable-variation"
                        onchange="updateVariationPrice('{{ product_id }}');">
                    {% for pvvv in variation_info["orderable_variation_children"][var] %}
                        <option value="{{ pvvv.pk }}">{{ pvvv.value }}</option>
                    {% endfor %}
                </select>
            </div>
        {% endfor %}
        {{ product_list_product_order_section(shop_product, quantity, variation_info["variation_orderable"], supplier=supplier) }}
    </div>
{% endmacro %}

{% macro product_list_simple_variation_form(shop_product, quantity, variation_info, supplier=None) %}
    {% set is_orderable = (variation_info.orderable_variation_children|length > 0) %}
    {% if shop_product.product.variation_parent %}
        {%- set product_id = shop_product.product.variation_parent.pk -%}
    {% else %}
        {%- set product_id = shop_product.product.pk -%}
    {% endif %}
    <div class="product-variations" id="simple-variations-{{ shop_product.product.id }}">
        <input type="hidden" name="command" value="add">
        <div class="form-group">
            <label for="product-variations">{% trans %}Select product{% endtrans %}</label>
            <select name="product_id"
                    id="product-variations"
                    class="form-control selectpicker"
                    onchange="updateVariationPrice('{{ product_id }}');">
                {% for p in variation_info.orderable_variation_children %}
                    <option value="{{ p.id }}"{% if selected_child and selected_child == p.id %} selected{% endif %}>
                        {{ p.variation_name or p.name }}
                    </option>
                {% endfor %}
            </select>
        </div>
        {{ product_list_product_order_section(shop_product, quantity, is_orderable, supplier=supplier) }}
    </div>
{% endmacro %}


{% macro product_list_simple_product_form(shop_product, quantity, supplier=None) %}
    <input type="hidden" name="command" value="add">
    <input type="hidden" name="product_id" value="{{ shop_product.product.id }}">
    {% set is_orderable=shop_product.is_orderable(supplier=None, customer=request.customer, quantity=quantity) %}
    <div class="prices">
        {{ product_list_product_order_section(shop_product, quantity, is_orderable, supplier=supplier) }}
    </div>
{% endmacro %}

{% macro product_list_product_order_section(shop_product, quantity, is_orderable, supplier=None) %}
    {% if show_prices() and not xtheme.get("hide_prices") %}
        <div class="row">
            <div class="col-sm-6 quantity-box-container">
                {% if not xtheme.get("catalog_mode") %}
                {{ product_list_quantity_box(shop_product, quantity) }}
                {% endif %}
            </div>
            <div class="col-sm-6 price-box-container">
                {{ product_list_product_price_div(shop_product, quantity, supplier=supplier) }}
            </div>
        </div>
        {% if not xtheme.get("catalog_mode") %}
            {{ product_list_add_to_cart_btn(shop_product, is_orderable) }}
        {% endif %}
    {% endif %}
{% endmacro %}

{% macro product_list_quantity_box(shop_product, quantity) %}
    {# TODO: see the performance of this...  #}
    {%- set show_sales_units = xtheme.show_sales_units() -%}
    {% if shop_product.product.variation_parent %}
        {%- set product_id = shop_product.product.variation_parent.pk -%}
    {% else %}
        {%- set product_id = shop_product.product.pk -%}
    {% endif %}
    <div class="text-left form-group amount">
        <label for="product-quantity-{{ product_id }}">{% trans %}Quantity{% endtrans %}</label>
        <div class="input-group">
            <input
                type="number"
                class="form-control product-quantity-field"
                name="quantity"
                id="product-quantity-{{ product_id }}"
                step="{{ shop_product.quantity_step }}"
                value="{{ quantity }}"
                min="{{ shop_product.rounded_minimum_purchase_quantity }}"
                onchange="updateVariationPrice('{{ product_id }}')"
            >
            {% if show_sales_units %}
            <span class="input-group-addon sales-unit">{{ shop_product.product.sales_unit.short_name }}</span>
            {% endif %}
        </div>
    </div>
{% endmacro %}

{% macro product_list_product_price_div(shop_product, quantity, supplier) %}
    {% if shop_product.product.variation_parent %}
        {%- set product_id = shop_product.product.variation_parent.pk -%}
    {% else %}
        {%- set product_id = shop_product.product.pk -%}
    {% endif %}
    {% set product = shop_product.product %}
    <div class="price text-right product-price-div product-{{ product_id }}">
        <h2>
            <span id="product-price"><strong>{{ product|price(quantity, supplier=supplier) }}</strong></span>
        </h2>
        <span class="small text-muted">
            {% if product|is_discounted(quantity, supplier=supplier) %}
            (<s>{{ product|base_unit_price(quantity, supplier=supplier) }}</s>)
            {% endif %}
            {{ product|discounted_unit_price(quantity, supplier=supplier) }}/{{ product.sales_unit.short_name }}
        </span>
    </div>
{% endmacro %}

{% macro product_list_add_to_cart_btn(shop_product, is_orderable) %}
    {% if not xtheme.get("catalog_mode") %}
        {% set orderable = (is_orderable and show_prices() and not xtheme.get("hide_prices")) %}
        {% set extra_class = "not-orderable" if not orderable else "" %}
        <div class="clearfix btn-add-to-cart">
            <button type="submit" class="btn btn-primary btn-block btn-lg add-to-cart-button {{ extra_class }}" {% if not orderable %} disabled{% endif %}>
                <i class="fa fa-shopping-cart"></i> {% trans %}Add to cart{% endtrans %}
            </button>
            <a
                href="{{ url('shuup:product', pk=shop_product.product.pk, slug=shop_product.product.slug) }}"
                class="btn btn-primary btn-block btn-view-details"
            >
                {% trans %}View details{% endtrans %}
            </a>
            {% if not orderable %}
            <p class="text-right text-muted">
                <i class="fa fa-info-circle text-info"></i> {% trans %}Product is not orderable.{% endtrans %}
            </p>
            {% endif %}
        </div>
    {% endif %}
{% endmacro %}
